<?php
/******************************************************************
 reformat_phonenr() Testen und Vereinheitlichen von Telefonnummern
 (c) 2002, Alex Aulbach for New Media Group

 GuptaSimpleCall2PHP.php - Sample
 18.04.2003 from Thomas Wiedmann http://www.twiedmann.de
*******************************************************************/

function reformat_phonenr($str) {
 # Regex 1
 # 0123/456789, 0123 45 67 89 usw.
 if ( ereg('^[[:space:]]*([^0-9]*0([1-9][0-9]+))[^0-9]+(([0-9]+[[:space:]]*)+)(-([0-9]{1,8}))?[[:space:]]*$',$str,$matches) ) {
  // print_r($matches);
  $matches[3]=ereg_replace('[[:space:]]','',$matches[3]);
  return("++49 ($matches[2]) $matches[3]$matches[5]");
 }
 # Regex 2
 # 0049 123 456789, 49 (123) 45 67 89, ++49 123/456789 usw.
 if ( ereg('^[[:space:]]*((00|\+\+)?([1-9][0-9]?))[^0-9]+([1-9][0-9]+)[^0-9]+(([0-9]+[[:space:]]*)+)(-([0-9]{1,8}))?[[:space:]]*$',$str,$matches) ) {
  // print_r($matches);
  $matches[5]=ereg_replace('[[:space:]]','',$matches[5]);
  return("++$matches[3] ($matches[4]) $matches[5]$matches[7]");
 }
 return(false);
}


/**
* PEAR
* Safely read the $argv PHP array across different PHP configurations.
* Will take care on register_globals and register_argc_argv ini directives
*
* @access public
* @return mixed the $argv PHP array or PEAR error if not registered
*/
function readPHPArgv()
{
    global $argv;
    if (!is_array($argv)) {
        if (!is_array($_SERVER['argv'])) {
            if (!is_array($HTTP_SERVER_VARS['argv'])) {
                ECHO "Could not read cmd args (register_argc_argv=Off?)\n";
            }
            return $HTTP_SERVER_VARS['argv'];
        }
        return $_SERVER['argv'];
    }
    return $argv;
}

/**
* main
* PHP reads arguments
*/

$argv = readPHPArgv();
$argc = count ($argv);
$number = null;

// the second paramater is the parameter file name
if ($argc == 2) {
 $file=$argv[1];
}

// check the second parameter, try to open the parameter file
if (is_file($file)) {
 $fp = fopen($file,'r+');

 if ($fp) {
  $sBuffer = fgets($fp, 4096);
  $sBuffer = strtoupper($sBuffer);
  // ECHO $sBuffer;

  // simple extract parameter <P1> without XML
  $nPos1 = strpos($sBuffer,"<P1>");
  $nPos2 = strpos($sBuffer,"</P1>");
  if ($nPos1 < $nPos2) {
    $number = substr($sBuffer,$nPos1+4,$nPos2-$nPos1-4);
    // ECHO "\nNumber=".$number;
  }

  // rewrite the temp. file
  rewind($fp);
  fputs($fp,'<?xml version="1.0" ?>');
  
  // check the phone number  
  if ( ( $phnr = reformat_phonenr($number) ) ==! false ) {
   fputs($fp,'<RETURNS><V1>'.$phnr.'</V1></RETURNS>');
  } else {
   fputs($fp,'<RETURNS><V1>invalid phone number</V1></RETURNS>');
  }

  fclose($fp);
 }
}

?>

